#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#-->                                                         <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 06/30/03                       <--#
#-->  V Pucknell  2005
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Sort_options GUI frame ......                           <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc sort_options {} {
    global env makefilepath mydebug
    global debugsort dsize
    global mydebug
    global running
    global update
    global tracesort tracelevel

    :frame FSOPT :label "MIDASSort: Sort Options" \
    :resize F :transient T
     :panel PFSO :layout V  :padx 5 :pady 5
      :layout H
      :message MFSO :label "MIDASsort: Sort options control frame" :bold T
      :next-row T
      :next-row T
       :checkbox CSDSO :label "Debug Sort" :value $debugsort :valuex 80 :command debug_level
      :hskip 48
      :button BDSO :label "Debug Levels" :command debug_options
      :next-row T
      :checkbox CBTO :label "Enable Trace" :value $tracesort :valuex 80
      :hskip 48
      if { $tracesort == 0 } then {
      :choice-stack CSTO :label "Trace Sort Level" :inactive T \
          :strings [list 0 1 2 3 4 5] :value $tracelevel
      } else {
      :choice-stack CSTO :label "Level" :inactive F \
          :strings [list 0 1 2 3 4 5] :value $tracelevel
      }
      :next-row T
      :next-row T
      :button BCFTAB    :label "User Variables"       :w 18  :command user_var
      :hskip 10
      if { $running == 0 } then {
        :button BGMTAB    :label "Gainmatching"       :w 12
      } else {
        :button BGMTAB    :label "Gainmatching"       :w 12 :inactive T
      }
      :next-row T
      if { $running == 0 } then {
        :button BGATETAB  :label "Gating"             :w 18
      } else {
        :button BGATETAB  :label "Gating"             :w 18 :inactive T
      }
      :hskip 10
      :button BVDATA    :label "View RawData"       :w 12  :command view_data

      :next-row T
      :next-row T
      :choice-stack CSDDSO :label "Update delay (s)  " \
    :value $update :strings [list 1 5 10 30 60 120 300 600] :inactive F
      :next-row T

    :show T
    
      if { $debugsort == 0 } then {:modify BDSO :inactive T} else {:modify BDSO :inactive F}
}

proc enable_set_trace { toggle } {
    global mydebug
    global tracesort tracelevel


    if { $toggle == 0 } then {
    set tracesort 0
    :modify CSTO :inactive T
    if { $mydebug == 1 } then { puts "enable_set_trace: tracesort set to $toggle" }
    } else {
    set good [ midas-confirmation "Are you sure you want to enable TRACE?\nThis could result in a very LARGE log file!" ]
    if { $good == 1 } then {
        set tracesort 1
        :modify CSTO :inactive F
        if { $mydebug == 1} then { puts "enable_set_trace: tracesort enabled!\n" }
    } else {
        if { $mydebug == 1 } then { puts "enable_set_trace: tracesort left unchanged (=$tracesort)" }
        set tracesort 0
        :modify CSTO :inactive T
        :modify CBTO :value $tracesort
    }
    }

    write_trace
}

proc set_trace_level { level } {
    global mydebug
    global tracesort tracelevel

    set tracelevel $level
    if { $mydebug == 1 } then { puts "enable_set_trace: tracelevel set to $level" }

    write_trace

}

proc write_trace { } {
    global mydebug
    global tracesort tracelevel

    if { $mydebug == 1 } then { puts "write_trace: Routine entered" }

    #--> check that the values are sensible ..
    if { $tracesort == 0 || $tracesort == 1 } then {
    if { $tracelevel >= 0 && $tracelevel < 6 } then {
        set rc [ catch { exec midasSortshm w 30 $tracesort } m ]
        set rc [ catch { exec midasSortshm w 31 $tracelevel } m ]
    } else {
        if { $mydebug == 1 } then { puts "write_trace: bad value of tracelevel (==$tracelevel)" }
    }
    } else {
    if { $mydebug == 1 } then { puts "write_trace: bad value of tracesort (==$tracesort)" }
    }

    if { $mydebug == 1 } then { puts "write_trace: Leaving ..." }

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> user_var.tcl : A total of 16 variables are provided     <--#
#-->                for the user to make use of. This GUI    <--#
#-->                can be used to set / change these        <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc user_var {} {
    global mydebug

    if { $mydebug == 1 } then { puts "user_var : Entered" }
    #--> First thing to do is to set up the GUI
    user_var.create
    if { $mydebug == 1 } then { puts "user_var : Leaving" }

}

proc user_var.create {} {
    global mydebug
    global uv1 uv2 uv3 uv4 uv5 uv6 uv7 uv8 uv9 uv10 uv11 uv12
    global uv13 uv14 uv15 uv16

    if { $mydebug == 1 } then { puts "user_var.create : Entered" }
    :frame FUSERVAR :label "MIDASsort: User Variables" :resize F :transient T
    :panel PUV1 :layout V :padx 5 :pady 5
     :layout H
     :message MUV1 :label "GUI to control user variables" :bold T
     :next-row T
     :next-row T
     :message MUV2 :label "Variables 1 - 4 are of type integer" :colour "-fg black"
     :next-row T
     :text TUV1 :label "UV1" :value $uv1 :w 11 :valuex 5c
     :hskip 10
     :text TUV2 :label "UV2" :value $uv2 :w 11 :valuex 5c
     :hskip 10
     :text TUV3 :label "UV3" :value $uv3 :w 11 :valuex 5c
     :hskip 10
     :text TUV4 :label "UV4" :value $uv4 :w 11 :valuex 5c
     :hskip 10
     :next-row T
     :message MUV3 :label "Variables 5 - 8 are of type unsigned integer" :colour "-fg black"
     :next-row T
     :text TUV5  :label "UV5" :value $uv5 :w 11 :valuex 5c
     :hskip 10                      
     :text TUV6  :label "UV6" :value $uv6 :w 11 :valuex 5c
     :hskip 10                      
     :text TUV7  :label "UV7" :value $uv7 :w 11 :valuex 5c
     :hskip 10                      
     :text TUV8  :label "UV8" :value $uv8 :w 11 :valuex 5c
     :hskip 10
     :next-row T
     :message MUV4 :label "Variables 9 - 12 are of type short" :colour "-fg black"
     :next-row T
     :text TUV9  :label "UV9 " :value $uv9  :w 11 :valuex 5c
     :hskip 10                        
     :text TUV10 :label "UV10" :value $uv10 :w 11 :valuex 5c
     :hskip 10                        
     :text TUV11 :label "UV11" :value $uv11 :w 11 :valuex 5c
     :hskip 10                        
     :text TUV12 :label "UV12" :value $uv12 :w 11 :valuex 5c
     :hskip 10
     :next-row T
     :message MUV5 :label "Variables 13 - 16 are of type float" :colour "-fg black"
     :next-row T
     :text TUV13 :label "UV13" :value $uv13 :w 11 :valuex 5c
     :hskip 10                        
     :text TUV14 :label "UV14" :value $uv14 :w 11 :valuex 5c
     :hskip 10                        
     :text TUV15 :label "UV15" :value $uv15 :w 11 :valuex 5c
     :hskip 10                        
     :text TUV16 :label "UV16" :value $uv16 :w 11 :valuex 5c
     :hskip 10
     :next-row T
     :next-row T
     :button BUV1 :label "Write to shared memory"  :command usr_var.write
    :show T
    if { $mydebug == 1 } then { puts "user_var.create : Leaving" }

}

proc user_var.write {} {
    global mydebug;
    global uv1 uv2 uv3 uv4 uv5 uv6 uv7 uv8 uv9 uv10 uv11 uv12
    global uv13 uv14 uv15 uv16

    for { set i 5 } { $i < 21 } { incr i } {
    set arg1 $i
    if { $i == 5 } then  { set arg2 [ scan $uv1 %i ] }
    if { $i == 6 } then  { set arg2 [ scan $uv2 %i ] }
    if { $i == 7 } then  { set arg2 [ scan $uv3 %i ] }
    if { $i == 8 } then  { set arg2 [ scan $uv4 %i ] }
    if { $i == 9 } then  { set arg2 [ scan $uv5 %u ] }
    if { $i == 10 } then { set arg2 [ scan $uv6 %u ] }
    if { $i == 11 } then { set arg2 [ scan $uv7 %u ] }
    if { $i == 12 } then { set arg2 [ scan $uv8 %u ] }
    if { $i == 13 } then { set arg2 [ scan $uv9 %i ] }
    if { $i == 14 } then { set arg2 [ scan $uv10 %i ] }
    if { $i == 15 } then { set arg2 [ scan $uv11 %i ] }
    if { $i == 16 } then { set arg2 [ scan $uv12 %i ] }
    if { $i == 17 } then { set arg2 [ scan $uv13 %f ] }
    if { $i == 18 } then { set arg2 [ scan $uv14 %f ] }
    if { $i == 19 } then { set arg2 [ scan $uv15 %f ] }
    if { $i == 20 } then { set arg2 [ scan $uv16 %f ] }
    if { $mydebug == 1 } then { puts "user_var.write : arg1 = $arg1  arg2 = $arg2" }
    set rc [ catch { exec midasSortshm w $arg1 $arg2 } ]
    }


}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> MIDAS interface for Sunsort                             <--#
#-->                                                         <--#
#--> Debug Info Frame                                        <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 07/15/03                       <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc debug_options args {
    global debuglevel

    :frame FDEBUGO :label "Debug Levels" :resize F :transient T
     :panel PDEBUGO :layout V  :padx 5 :pady 5
      :layout H
      :message MDEBUGO :label "MIDASsort: Debug Level control frame" :bold T
      :next-row T
      :next-row T
      :checkbox CBDOALL :label "All Debug statements" :value $debuglevel(all) :command set_debug_level
      :next-row T
      :next-row T
      :message MDEBUGO1 :label "User Debug Levels" :bold T
      :next-row T
      :checkbox CBDOU0  :label "All" :value $debuglevel(user0) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOU1  :label "User1" :value $debuglevel(user1) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOU2  :label "User2" :value $debuglevel(user2) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOU3  :label "User3" :value $debuglevel(user3) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOU4  :label "User4" :value $debuglevel(user4) :valuex 7c :command set_debug_level
 
      :next-row T
      :message MDEBUGO2 :label "Library Debug Levels" :bold T
      :next-row T
      :checkbox CBDOL0  :label "All" :value $debuglevel(sortcalls) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOL1  :label "Inc1d" :value $debuglevel(inc1d) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOL2  :label "Inc2d" :value $debuglevel(inc2d) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOL3  :label "ConvID" :value $debuglevel(ucid) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOL4  :label "Gmatch" :value $debuglevel(ugm) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOL5  :label "Hist" :value $debuglevel(ugm) :valuex 7c :command set_debug_level
 
      :next-row T
      :message MDEBUGO3 :label "Main Sort Debug Levels" :bold T
      :next-row T
      :checkbox CBDOMS0  :label "All" :value $debuglevel(maina) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOMS6  :label "Main" :value $debuglevel(main) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOMS5  :label "Parse" :value $debuglevel(parse_args) :valuex 7c :command set_debug_level
      :hskip 10 
      :checkbox CBDOMS1  :label "Spectra" :value $debuglevel(spectra) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOMS4  :label "Getblk" :value $debuglevel(get_block) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOMS3  :label "Decipher" :value $debuglevel(decipher) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDOMS7  :label "Shared" :value $debuglevel(shared) :valuex 7c :command set_debug_level

      :next-row T
      :checkbox CBDOMS2  :label "Final" :value $debuglevel(end_prog) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBDUI  :label "Uint" :value $debuglevel(uinteract) :valuex 7c :command set_debug_level
      :hskip 10
      :checkbox CBGAT  :label "Gate" :value $debuglevel(gate) :valuex 7c :command set_debug_level

      :next-row T
      :hskip 700
      :button BDOSO :label "Save Debug levels" :command save_debug_levels

    :show T
      
}


proc set_debug_level {w v} {
    global debuglevel
    
    switch -glob $w {

    CBDOALL          { setalld $v }
    CBDOU0           { setuserd $v }
    CBDOU*           { set debuglevel(user[string range $w 5 end]) $v }

    CBDOL0           { setlibd $v }
    CBDOL1           { set debuglevel(inc1d) $v }
    CBDOL2           { set debuglevel(inc2d) $v }
    CBDOL3           { set debuglevel(ucid) $v }
    CBDOL4           { set debuglevel(ugm) $v }
    CBDOL5           { set debuglevel(hist) $v }
    
    CBDOMS0          { setmaind $v }
    CBDOMS1          { set debuglevel(spectra) $v }
    CBDOMS2          { set debuglevel(end_prog) $v }
    CBDOMS3          { set debuglevel(decipher) $v }
    CBDOMS4          { set debuglevel(get_block) $v }
    CBDOMS5          { set debuglevel(parse_args) $v }
    CBDOMS6          { set debuglevel(main) $v }
    CBDOMS7          { set debuglevel(shared) $v }
    
    CBDUI            { set debuglevel(uinteract) $v }
    CBGAT            { set debuglevel(gate) $v }
    }
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setalld arg {
    global debuglevel 
    global mydebug
    
    if { $mydebug == 1 } then {
    puts "setalld : arg = $arg"
    }

    set searchid [ array startsearch debuglevel ]
    while { [ array anymore debuglevel $searchid ] } {
    set element [ array nextelement debuglevel $searchid ]
    set debuglevel($element) $arg
    }
    array donesearch debuglevel $searchid

    modify_dlevel 0

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setuserd arg {
    global debuglevel 
    global mydebug
    
    if { $mydebug == 1 } then {
    puts "setuserd : arg = $arg"
    }

    for { set i 0 } { $i < 10 } { incr i } {
    set val user$i
    set debuglevel($val) $arg
    if { $mydebug == 1 } then {
        puts "debuglevel($val) = $debuglevel($val)"
    }
    }

    modify_dlevel 0

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setlibd arg {
    global debuglevel 
    global mydebug
    
    if { $mydebug == 1 } then {
    puts "setlibd : arg = $arg"
    }

    set debuglevel(sortcalls) $arg
    set debuglevel(inc1d) $arg
    set debuglevel(inc2d) $arg
    set debuglevel(ucid) $arg
    set debuglevel(ugm) $arg
    set debuglevel(hist) $arg
    set debuglevel(gate) $arg

    modify_dlevel 0

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setmaind arg {
    global debuglevel 
    global mydebug
    
    if { $mydebug == 1 } then {
    puts "setmaind : arg = $arg"
    }

    set debuglevel(maina) $arg
    set debuglevel(main) $arg
    set debuglevel(spectra) $arg
    set debuglevel(end_prog) $arg
    set debuglevel(decipher) $arg
    set debuglevel(get_block) $arg
    set debuglevel(parse_args) $arg
    set debuglevel(shared) $arg

    modify_dlevel 0

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc modify_dlevel arg {
    global debuglevel

    :modify CBDOALL :value $debuglevel(all)
    :modify CBDOU0 :value $debuglevel(user0)
    :modify CBDOU1 :value $debuglevel(user1)
    :modify CBDOU2 :value $debuglevel(user2)
    :modify CBDOU3 :value $debuglevel(user3)
    :modify CBDOU4 :value $debuglevel(user4)
    :modify CBDOL0 :value $debuglevel(sortcalls)
    :modify CBDOL1 :value $debuglevel(inc1d)
    :modify CBDOL2 :value $debuglevel(inc2d)
    :modify CBDOL3 :value $debuglevel(ucid)
    :modify CBDOL4 :value $debuglevel(ugm)
    :modify CBDOL5 :value $debuglevel(hist)
    :modify CBDOMS0 :value $debuglevel(maina) 
    :modify CBDOMS6 :value $debuglevel(main) 
    :modify CBDOMS1 :value $debuglevel(spectra) 
    :modify CBDOMS2 :value $debuglevel(end_prog) 
    :modify CBDOMS3 :value $debuglevel(decipher) 
    :modify CBDOMS4 :value $debuglevel(get_block) 
    :modify CBDOMS5 :value $debuglevel(parse_args) 
    :modify CBDOMS7 :value $debuglevel(shared) 
    :modify CBDUI   :value $debuglevel(uinteract) 
    :modify CBGAT   :value $debuglevel(gate) 

    update idletasks
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc save_debug_levels {} {
    global debuglevel
    global mydebug
    global debugsort
    global running

    midas-check-for-temp
    set z [ catch { open "debug.info" w } f ]
    if { $z == 0 } then {
    set searchid [ array startsearch debuglevel ]
    while { [ array anymore debuglevel $searchid ] } {
        set element [ array nextelement debuglevel $searchid ]
        if { $mydebug == 1 } then {
        puts "$element = $debuglevel($element)"
        }
        if {$z != 0} then {
        midas-warning "Unable to write file debug.info\n$f"
        return
        } else {
        puts $f "$element $debuglevel($element)"
        }
    }
    array donesearch debuglevel $searchid
    
    close $f

    if { $running == 1 } then {
        if { $debugsort == 1 } then {
        set rc [catch { exec midasSortshm w 2 1 } m]
        }
    }
    }
    destroy-frame FDEBUGO
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> set the debug level for the sort                        <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc debug_level {w vl} {
    global debugsort
    global running
    global mydebug

    set debugsort $vl

    if { $debugsort == 0 } then {
    :modify BDSO :inactive T
    } else {
    :modify BDSO :inactive F
    }
    update idletasks

    if { $running == 1 } then {
    if { $debugsort == 0 } then {
        set rc [catch { exec midasSortshm w 2 0 } m]
    } else {
        set rc [catch { exec midasSortshm w 2 1 } m]
    }
    } 

}


#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> view_data.tcl : Launced from sort options. Allows the   <--#
#-->                 user to view their raw data that is     <--#
#-->                 being processed by the sort program.    <--#
#-->                                                         <--#
#--> D.Appelbe Daresbury NPG 01/05/04                        <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc view_data {} {
    global mydebug
    global running
    #--> Create the GUI
    viewData.createFrame
    #--> Configure the tags that we shall use ....
    viewData.configure_tags
    #--> If we are running lets display some data
    if { $mydebug == 1 } then { puts "viewData : running = $running" }
    if { $running == 1 } then {
    viewData.redisplay
    }
    #--> Else it is up to the user to sort things out
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc viewData.createFrame {} {
    global mydebug
    global vdcurrent_pos
    global vdpos
    global vdaspos
    global vdpostrue

    set vdcurrent_pos "Current position in block is : 0"
    set vals        [ list "From start" \
               "Current -1024" "Current -512" "Current -256" \
               "Current -128" "Current -64" "Current -32" \
               "Current position" \
               "Current +32" "Current +64" "Current +128" \
               "Current +256" "Current +512" "Current +1024" \
               "Range +/- 1024" "Range +/- 512" "Range +/- 256" \
               "Range +/- 128" "Range +/- 64" "Range +/- 32"
             ]
    set vdpostrue   [ list 0 -1024 -512 -256 -128 -64 -32 -1 32 64 128 256 512 1024 \
               10024 9512 9256 9128 9064 9032 ]
    set asvals      [ list "8bit" "16bit" "32bit" ]

    :frame FVIEWDATA :label "MIDASsort: Data Viewer" :resize F :transient T
     :panel PVIEWDATA :layout V :padx 10 :pady 10
      :layout H
      :message MVD1 :label $vdcurrent_pos :bold T
      :next-row T
      :galley GVD1 :cols 100 :rows 40 :deaf T :font fixed :see 0 :scroll V
      :next-row T
      :choice-stack CSVD1 :label "View from" :strings $vals :value $vdpos
      :hskip 40
      :choice-stack CSVD2 :label "View as" :strings $asvals :value $vdaspos
      :hskip 20
      :button BVD2 :label "Show" :command viewData.redisplay
      :hskip 20
      :button BVD1 :label "Cancel" :command viewData.cancel
    
    :show T

    if { $mydebug == 1 } then { puts "viewData.createFrame : Leaving Routine" }
}

proc viewData.cancel {} {
    destroy-frame FVIEWDATA
}

proc viewData.redisplay {} {
    global mydebug

    if { $mydebug == 1 } then { puts "viewData.redisplay : Entering Routine" }
    #--> First run the data format program
    set arg1 [ viewData.setrange ]
    set arg2 [ viewData.setbits ]
    set arg3 "r"
    if { $mydebug == 1 } then { puts "viewData.redisplay : range -> $arg1" }
    if { $mydebug == 1 } then { puts "viewData.redisplay : bits  -> $arg2" }

    set contents ""
    set z [ catch { exec "midasSortfb" $arg1 $arg2 $arg3 } contents ]
    if { $z != 0 } then { midas-error "Could not run midasSortfb" }
    if { $mydebug == 1 } then { puts "viewData.redisplay : z  -> $z" }

    #--> Now read the data from the disc file
        midas-check-for-temp
    set z [ catch { open "msdata.txt" r } f ]
    if { $z == 0 } then {
    gets $f m
    close $f
    } else {
    if { $mydebug == 1 } then { puts "viewData.redisplay : Could not open msdata.txt" }
    }

    set vdcurrent_pos "Current position in block is : $m"
    :modify MVD1 :label $vdcurrent_pos

    #--> So here we do something semi nifty so that it is easy to see
    #--> the data word corresponding ground zero
    #--> First which line of the data will it be on?
    set start [ viewData.getstart $arg1 $arg2 $m ]
    set stop  [ expr [ viewData.getstop $arg1 $arg2 $m ] + 1 ]
    if { $mydebug == 1 } then { puts "viewData.redisplay : start = $start" }
    if { $mydebug == 1 } then { puts "viewData.redisplay : stop = $stop" }
    #--> So there are 8 data wrds per line so which line are we interested in?
    set numlines [ expr [ expr $stop - $start ] / 8 ]
    if { $arg2 == 32 } then { set numlines [ expr $numlines / 2 ] }
    if { $numlines == 0 } then { set numlines 1 }
    if { $mydebug == 1 } then { puts "viewData.redisplay : numlines = $numlines" }
    if { $arg1 == -1 } then {
    set line 1
    set wrd  2
    }

    if { $arg1 > 0 } then {
    if { $arg1 < 9000 } then {
        set line 1
        set wrd 1
    } else {
        set line [ expr [ expr $numlines / 2 ] + 1 ]
        set wrd 1
    }
    } 
    if { $arg1 < -1 } then {
    set line $numlines
    set wrd 8
    }

    set mywrd [ expr [ expr [ expr [ expr [ expr $line - 1 ] * 8 ] + $wrd ] + 6 ] + [ expr $line * 2 ] ]

    if { $mydebug == 1 } then { puts "viewData.redisplay : arg1 = $arg1" }
    if { $mydebug == 1 } then { puts "viewData.redisplay : line = $line" }
    if { $mydebug == 1 } then { puts "viewData.redisplay : wrd  = $wrd" }
    if { $mydebug == 1 } then { puts "viewData.redisplay : mywrd= $mywrd" }

    :modify GVD1 :empty T
    set wrdctr 1
    set date 1
    set posctr 1
    foreach w $contents {
    if { $mydebug == 1 } then { puts "wrd($wrdctr/$posctr) = $w" }
    if { $date == 1 } then {
        :modify GVD1 :usingtag tagbase :strings $w
        :modify GVD1 :usingtag tagbase :strings " "
        set posctr [ expr $posctr + 1 ]
        if { $posctr == 7 } then {
        set date 0
        set posctr 1
        :modify GVD1 :usingtag tagbase :strings "\n"
        }
    } else {
        if { $posctr > 2 } then {
        if { $wrdctr == $mywrd } then {
            :modify GVD1 :usingtag tagstart :strings [ format "%-9s" $w ]
            :modify GVD1 :usingtag tagstart :strings " "
        } else {
            :modify GVD1 :usingtag tagbase :strings [ format "%-9s" $w ]
            :modify GVD1 :usingtag tagbase :strings " "
        }
        } else {
        :modify GVD1 :usingtag tagbase :strings [ format "%6s" $w ]
        :modify GVD1 :usingtag tagbase :strings " "
        }
        set posctr [ expr $posctr + 1 ]
        if { $posctr == 11 } then {
        set posctr 1
        :modify GVD1 :usingtag tagbase :strings "\n"
        }        
    }

    set wrdctr [ expr $wrdctr + 1 ]
    }


    if { $mydebug == 1 } then { puts "viewData.redisplay : Leaving Routine" }
}

proc viewData.setrange {} {
    global vdpos
    global vdpostrue

    return [ lindex $vdpostrue $vdpos ]
}

proc viewData.setbits {} {
    global vdaspos

    switch $vdaspos {
    0         { return  8 }
    1         { return 16 }
    2         { return 32 }
    }

}

proc viewData.configure_tags {} {
    global mydebug

    if { $mydebug == 1 } then { puts "viewData.configure_tags : Entered" }
    :modify GVD1 :createtag "tagbase  -foreground blue"
    :modify GVD1 :createtag "tagstart -foreground red"
    if { $mydebug == 1 } then { puts "viewData.configure_tags : Leaving" }

}

proc viewData.getstart args {
    global mydebug

    if { $mydebug == 1 } then { puts "viewData.getstart: In Routine" }
    set range [ first $args ]
    if { $mydebug == 1 } then { puts "viewData.getstart: Range = $range" }
    set bits  [ second $args ]
    if { $mydebug == 1 } then { puts "viewData.getstart: bits = $bits" }
    set base  [ third $args ]
    if { $mydebug == 1 } then { puts "viewData.getstart: base = $base" }

    if { $range < 0 } then {
    set tmp [ expr $base + $range ]
    if { $tmp > -1 } then {
        set start $tmp
    } else {
        set start 0
    }
    if { $mydebug == 1 } then { puts "viewData.getstart: start = $start" }
    } 

    if { $range > 0 } then {
    if { $range < 9000 } then {
        set start $base
    } else {
        set range [ expr $range - 9000 ]
        set tmp [ expr $base - $range ]
        if { $tmp > -1 } then {
        set start $tmp
        } else {
        set start 0
        }
    }
    }

    if { $bits == 32 } then {
    set start [ expr $start / 2 ]
    set start [ expr $start * 2 ]
    }

    if { $mydebug == 1 } then { puts "viewData.getstart: start = $start" }
    if { $mydebug == 1 } then { puts "viewData.getstart: Out of Routine" }
    return $start
}

proc viewData.getstop args {
    global mydebug

    if { $mydebug == 1 } then { puts "viewData.getstop: In Routine" }
    set range [ first $args ]
    if { $mydebug == 1 } then { puts "viewData.getstop: Range = $range" }
    set bits  [ second $args ]
    if { $mydebug == 1 } then { puts "viewData.getstop: bits = $bits" }
    set base  [ third $args ]
    if { $mydebug == 1 } then { puts "viewData.getstop: base = $base" }

    if { $range < 0 } then {
    set stop $base
    if { $mydebug == 1 } then { puts "viewData.getstop: stop = $stop" }
    } 

    if { $range > 0 } then {
    if { $range < 9000 } then {
        set tmp [ expr $base + $range ]
        if { $tmp < 32768 } then {
        set stop $tmp
        } else {
        set stop 16384
        }
    } else {
        set range [ expr $range - 9000 ]
        set tmp [ expr $base + $range ]
        if { $tmp < 32768 } then {
        set stop $tmp
        } else {
        set stop 16384
        }
    }
    }

    if { $range == -1 } then {
    set stop [ expr $base + 7 ]
    }

    if { $bits == 32 } then {
    set stop [ expr $stop / 2 ]
    set stop [ expr $stop * 2 ]
    }

    if { $mydebug == 1 } then { puts "viewData.getstop: stop = $stop" }
    if { $mydebug == 1 } then { puts "viewData.getstop: Out of Routine" }
    return $stop
}

